<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

class Hg_Output {
	protected static $instance = null;

	protected $output = array();

	public function __construct($output) {
		$this->output = $output;
	}

	public static function getInstance($output) {
		if (self::$instance === null) {
			self::$instance = new Hg_Output($output);
		}

		return self::$instance;
	}

	public function set($output) {
		$this->output = $output;
	}

	public function format($format = null) {
		switch ($format) {
			case 'yaml':
				if (!class_exists('sfYaml')) {
					throw new Hg_Execption('Could not convert output to yaml cause of missing yaml support.');
				}

				$output = sfYaml::dump($this->output);

				break;

			case 'json':
				$output = json_encode($this->output);

				break;

			case 'paragraph':
				$output = array();

				foreach ($this->output as $line) {
					if ($line) {
						$output[] = '<p>' . $line . '</p>';
					}
				}

				$output = implode($output);

				break;

			default:
				$output = '';

				foreach ($this->output as $line) {
					$output .= $line . PHP_EOL;
				}

				break;
		}

		$this->output = $output;

		return $this;
	}

	public function get() {
		return $this->output;
	}

	public function __toString() {
		return $this->output ? $this->output : 'Mercurial output console is empty.';
	}
}
