<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Mercurial util directory class
 */
class Mercurial_Util_Directory {
	/**
	 * Constrcutor
	 */
	public function __construct() {}

	/**
	 * Get base directories
	 *
	 * @return <string> JSON encoded array of directories
	 */
	public function getBaseDirectories() {
		$directories[] = array(
			'data'     => basename(SLY_BASE),
			'attr'     => array('url' => SLY_BASE, 'id' => 'root'),
			'children' => $this->getSubDirectories(SLY_BASE)
		);

		return $directories;
	}

	/**
	 * Get sub directories
	 *
	 * @return <array> Array of sub directories
	 */
	public function getSubDirectories($path, $children = array()) {
		$directory   = new sly_Util_Directory($path);
		$directories = $directory->listPlain(false);

		if ($directories) {
			foreach ($directories as $key => $value) {
				$title    = $value;
				$fullpath = $path . DIRECTORY_SEPARATOR . $value;

				$children[] = array(
					'data'     => $title,
					'attr'     => array('url' => $fullpath, 'id' => $fullpath),
					'children' => $this->getSubDirectories($fullpath)
				);
			}

			return $children;
		}
	}
}
